//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "classListElement.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
	HINSTANCE g_hInst;
	HWND        hwndListView;
//	HIMAGELIST  himlSmall; //  Unit1.h
//	HIMAGELIST  himlLarge; //  Unit1.h
	g_hInst=GetModuleHandle(NULL);
	hwndListView=ListView1->Handle;
	//set the image lists
	himlSmall = ImageList_Create(16, 16, ILC_COLORDDB | ILC_MASK, 1, 0);
	himlLarge = ImageList_Create(32, 32, ILC_COLORDDB | ILC_MASK, 1, 0);

	if (himlSmall && himlLarge)
	{
		HICON hIcon;

		//set up the small image list
		hIcon = LoadImage(g_hInst, "MYICON", IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
		ImageList_AddIcon(himlSmall, hIcon);

		//set up the large image list
		hIcon = LoadIcon(g_hInst, "MYICON");
		ImageList_AddIcon(himlLarge, hIcon);

		ListView_SetImageList(hwndListView, himlSmall, LVSIL_SMALL);
		ListView_SetImageList(hwndListView, himlLarge, LVSIL_NORMAL);
	}
	for(int i = 0; i < ListElementsCount; i++)
	{
		ListElements[i] = new TListElement();
		*(ListElements[i]->Caption) = Format("Item %d",ARRAYOFCONST((i + 1)));
		for(short int j = 0; j < SubStringsCount; j++)
			*(ListElements[i]->SubStrings[j]) = Format( "Item %d - Column %d",	ARRAYOFCONST((i + 1, j + 1)));
	}
}
//---------------------------------------------------------------------------
__fastcall TForm1::~TForm1(void)
{
	for(int i = 0; i < ListElementsCount; i++)
	{
		delete ListElements[i];
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AboutControls1Click(TObject *Sender)
{
	FormAbout->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::LargeIcons1Click(TObject *Sender)
{
	LargeIcons1->Checked=true;
	LargeIcons2->Checked=true;
	for(int i=0; i < ListView1->Columns->Count; i++)
		ListView_SetColumnWidth(ListView1->Handle,i,120);
	ListView1->ViewStyle=vsIcon;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SmallIcons1Click(TObject *Sender)
{
	SmallIcons1->Checked=true;
	SmallIcons2->Checked=true;
	for(int i=0; i < ListView1->Columns->Count; i++)
		ListView_SetColumnWidth(ListView1->Handle,i,120);
	ListView1->ViewStyle=vsSmallIcon;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::List1Click(TObject *Sender)
{
	List1->Checked=true;
	List2->Checked=true;
 for(int i=0; i < ListView1->Columns->Count; i++)
		ListView_SetColumnWidth(ListView1->Handle,i,120);
	 ListView1->ViewStyle=vsList;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Details1Click(TObject *Sender)
{
	Details1->Checked=true;
	Details2->Checked=true;
	for(int i=0; i < ListView1->Columns->Count; i++)
		ListView_SetColumnWidth(ListView1->Handle,i,120);
	ListView1->ViewStyle=vsReport;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ListViewOnDataAPI(TObject *Sender, TListItem *Item)
{
	TListView *Lv=(TListView *)Sender;
			//OnData gets called once for each item for which the ListView needs
			//data. If the ListView is in Report View, be sure to add the subitems.
			//Item is a "dummy" item whose only valid data is it's index which
			//is used to index into the underlying data.
	Item->ImageIndex=0;
	Item->Caption = *(ListElements[Item->Index]->Caption);
	if (Lv->ViewStyle == vsReport)
	{
		for(int i = 0; i < Lv->Columns->Count-1; i++)
		{
		 Item->SubItems->Add(*(ListElements[Item->Index]->SubStrings[i]));
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VCL1Click(TObject *Sender)
{
 for(int i=0; i < ListView1->Columns->Count; i++)
		ListView_SetColumnWidth(ListView1->Handle,i,120);

	ListView1->OwnerData = false;
	ListView1->OnData = NULL;
	Screen->Cursor = crHourGlass;
	ListView1->Items->BeginUpdate();
	ListView1->Items->Clear();
	ListView_SetImageList(ListView1->Handle, himlSmall, LVSIL_SMALL);
	ListView_SetImageList(ListView1->Handle, himlLarge, LVSIL_NORMAL);
	start_time = Time();
	for(int i = 0; i < ListElementsCount; i++)
	{
		li = ListView1->Items->Add();
		li->ImageIndex = 0;
		li->Caption = *(ListElements[i]->Caption);
		//if (ListView1->ViewStyle == vsReport)
			for(int s = 0; s < ListView1->Columns->Count - 1; s++)
			{
				li->SubItems->Add(*(ListElements[i]->SubStrings[s]));
			}
	}
	end_time = Time();
	ListView1->Items->EndUpdate();
	Screen->Cursor = crDefault;
	ShowMessage("done with " + TimeToStr(end_time - start_time));
}
//---------------------------------------------------------------------------
void __fastcall TForm1::API1Click(TObject *Sender)
{
	for(int i=0; i < ListView1->Columns->Count; i++)
		ListView_SetColumnWidth(ListView1->Handle,i,120);
	ListView1->Items->BeginUpdate();
	ListView1->Items->Clear();
	ListView1->Items->EndUpdate();
	ListView1->OnData = ListViewOnDataAPI;
	ListView1->OwnerData = true;
	ListView_SetImageList(ListView1->Handle, himlSmall, LVSIL_SMALL);
	ListView_SetImageList(ListView1->Handle, himlLarge, LVSIL_NORMAL);
	Screen->Cursor = crHourGlass;
	start_time = Time();
	ListView1->Items->Count = ListElementsCount;
	end_time = Time();
	Screen->Cursor = crDefault;
	ShowMessage("done with " + TimeToStr(end_time - start_time));
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VCLCountAdd1Click(TObject *Sender)
{
 for(int i=0; i < ListView1->Columns->Count; i++)
		ListView_SetColumnWidth(ListView1->Handle,i,120);

	ListView1->OwnerData = false;
	ListView1->OnData = NULL;
	Screen->Cursor = crHourGlass;
	ListView1->Items->BeginUpdate();
	ListView1->Items->Clear();
	ListView_SetImageList(ListView1->Handle, himlSmall, LVSIL_SMALL);
	ListView_SetImageList(ListView1->Handle, himlLarge, LVSIL_NORMAL);
	start_time = Time();
	ListView1->Items->Count = 10000;
	/*
	procedure TListItems.SetCount(Value: Integer);
	begin
		ListView_SetItemCountEx(Handle, Value, LVSICF_NOINVALIDATEALL);  ???  -     
	end;
	*/
	for(int i = 0; i < ListElementsCount; i++)
	{
		li = ListView1->Items->Add();
		li->ImageIndex = 0;
		li->Caption = *(ListElements[i]->Caption);
		//if (ListView1->ViewStyle == vsReport)
			for(int s = 0; s < ListView1->Columns->Count - 1; s++)
			{
				li->SubItems->Add(*(ListElements[i]->SubStrings[s]));
			}
	}
	end_time = Time();
	ListView1->Items->EndUpdate();
	Screen->Cursor = crDefault;
	ShowMessage("done with " + TimeToStr(end_time - start_time));
}
//---------------------------------------------------------------------------

